if (!window.File) {
	alert("お使いのブラウザはFile APIに対応していない為、このサービスを利用できません。Google Chromeの最新版などをご利用ください。");
}

$(function(){
	var reader;

	$("#clearButton").click(function(){

		$("#clearZone").append("<message><div><font size=2 color=#555>消去しました。</font></div></message>");
		$("#result").html("");
		$("#files").val("");
		
		setTimeout(function(){
			$("#clearZone").fadeOut("slow",function(){
				$("#clearZone").find("message").remove();
		});
		},500)

	});

	$("footer").mouseover(function(){
		$(this)
		.css("filter","alpha(opacity=1)")
		.css("opacity","1");
	});

	$("footer").mouseout(function(){
		$(this)
		.css("filter","alpha(opacity=70)")
		.css("opacity","0.7");
	});


	$('#files').change(handleFileSelect);

	//DragDrop
	$("body").on('dragover',handleDragOver);
	$("body").on('drop', DragHandleFileSelect);
});


function abortRead() {
	reader.abort();
}

function errorHandler(evt) {
	switch(evt.target.error.code) {
		case evt.target.error.NOT_FOUND_ERR:
		alert('File Not Found!');
	break;
		case evt.target.error.NOT_READABLE_ERR:
		alert('File is not readable');
	break;
		case evt.target.error.ABORT_ERR:
		break; // noop
	default:
		alert('An error occurred reading this file.');
	};
}

function handleFileSelect(evt) {

	$("#clearZone").fadeIn("slow");

	var entries = evt.target.files;
	var count = 0;

	for (var i=0; i< entries.length ; i++) {
		var reader = new FileReader();
		reader.onloadend = (function(file) {
			return function(e) {

				var d = file.lastModifiedDate;
				var time = toZero(d.getHours()) + ":" + toZero(d.getMinutes()) + ":" + toZero(d.getSeconds());

				var html = "<table id='table"+count+"'>" +
				           "<tr><td><b>File:</b></td><td>" + file.name + "</b></td></tr>" + 
				           "<tr><td><b>MD5:</b></td><td><font color=red><MD5> <font color=#999 size=2><img src=lib/loading.gif> 処理中..</font></MD5></font><br>" + 
				           "<tr><td><b>SHA1:</b></td><td><font color=red><SHA-1> <font color=#999 size=2><img src=lib/loading.gif> 処理中..</font></SHA-1></font><br>" + 
				           "<tr><td><b>SHA256:</b></td><td><font size=2 color=red><SHA-256> <font color=#999 size=2><img src=lib/loading.gif> 処理中..</font></SHA-256></font><br>" + 
				           "<tr><td><b>SHA512:</b></td><td><font size=1 color=red><SHA-512> <font color=#999 size=2><img src=lib/loading.gif> 処理中..</font></SHA-512></font><br>" + 
				           "<tr><td><b>Type:</b></td><td>" + (file.type || 'n/a') + "</td></tr>" + 
				           "<tr><td><b>Size:</b></td><td>" + parseByte(file.size) + "</td></tr>" + 
				           "<tr><td><b>Date:</b></td><td>"+ (file.lastModifiedDate.toLocaleDateString() + " " + time) + "</td></tr>" + 
				           "</table>" + 
				           "<hr>";

				$("#result")
				.css("width",'100%')
				.prepend(html);

				setTimeout(function(count,e){
					var md5sum = MD5_hexhash(e.target.result);
					$("#table"+count).find("MD5").html(md5sum);
				},100,count,e);


				var algs = ["SHA-1","SHA-256","SHA-512"];
				$(algs).each(function(i){
					setTimeout(function(count,e,alg){
						var hashObj = new jsSHA(e.target.result, "TEXT");
						$("#table"+count).find(alg).html(hashObj.getHash(alg, "HEX"));
					},100,count,e,algs[i]);
				});



				count++;

			};
		})(entries[i]);

		reader.readAsBinaryString(entries[i]);
	}

}

function toZero(n){

	return n<10?"0"+n:n;
}

function parseByte(byte){
	if(byte < 1024){
		return byte + "byte";
	} else if(byte < 1024*1000){
		return parseFloat(byte/1024).toFixed(2) + "KB";
	} else {
		return parseFloat(byte/1024/1024).toFixed(2) + "MB";
	}
}

function DragHandleFileSelect(e) {
	e.preventDefault();
	e.stopPropagation();
	e.target.files = e.originalEvent.dataTransfer.files;
	handleFileSelect(e);
}

function handleDragOver(e) {
	e.preventDefault();
	e.stopPropagation();
	e.dataTransfer.dropEffect = 'copy';
}
